/***********************************************************************
*   $Id$
*   descr:      fifo class efficient because of no memory allocation
*   author:     DIVIN Abel
*
*   $Log$
*
************************************************************************/

#ifndef _Fifo_INC
#define _Fifo_INC

class Fifo;

class FifoItem {
  friend class Fifo;
  FifoItem *next;
 public:
  virtual ~FifoItem() {}
};

class Fifo {
  FifoItem *first;
  FifoItem *last;
public:
  Fifo();

  // delete all items inside the fifo
  ~Fifo();

  // put an item in Fifo
  void Put(FifoItem *m);

  // extract and return the reference to the first item from Fifo
  // NULL if no item in Fifo
  FifoItem *Get();

  // return the reference to the first item from Fifo without extracting it
  // NULL if no item in Fifo
  FifoItem *ReadFirst();

  // return 1 if Fifo is empty, 0 otherwise
  int Empty();
};
  
#endif
