/***********************************************************************
*   $Id$
*   descr:      class Parser to extract tokens from a string given a list
*               of character separators
*   author:     DIVIN Abel
*
*   $Log$
*
************************************************************************/

#ifndef _PARSER_INC
#define _PARSER_INC

#include <stdio.h>

#define _P_MAX_STRLEN 256

class Parseur {
  char str[_P_MAX_STRLEN];
  char *currentPos;
  char *oldPos;
  char separators[_P_MAX_STRLEN];
  int len;

  void PrepareString(char *);

  short IsASeparator(char);

public:
  Parseur(
    // in: string to be parsed
    char *str,

    // in: contains all chars succeptible to be separators
    char *separators = NULL
  );

  // return a pointer to the current token (private string)
  // returned string must not be modified, and deallocated
  // return NULL if end of str encountered
  char *GetNextToken();
};

#endif
