/*
 * Module UnixGate : SC++ UNIX gate class to interact with UNIX sockets
 * Author: Divin Abel
 */

#ifndef _SCPP_UnixGate_h
#define _SCPP_UnixGate_h

// import SystemType type definition
#include <scxx.h>

// import socket lib for 'struct sockaddr'
#define accept __SCXX_UNIX_ACCEPT
#define select __SCXX_UNIX_SELECT
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#undef accept
#undef select

active class UnixGate {
public:
  UnixGate(SystemType::FileDescr sock, SystemType::Mode mode, int debug=0);
    
  void Accept(void);

  ~UnixGate();

private:
  SystemType::FileDescr descr;
  SystemType::Mode mode;
  
  void Init();

  @UnixGate();
};

#endif // _SCPP_Unixgate_h
